function [Rx, Ry] = CalcResponseMatrix_PETSOffset(IF, p)
clight = 299792458;	% [m/s]

%% Define all drifts, quads etc.
l_cor = 0.240;
l_bpm = 0.126;

% Kicker 1 here (middle)
% d = l_cor/2 + 0.970 + 0.25;
% M4_01 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% l_dipole = 0.450; d = l_dipole;
% M4_RB = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% d = 1.41;
% M4_02 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% l_qf1 = 0.300; fqdl4 = clight*1e-6*0.335;
% k = abs(fqdl4 * IF1 / p); phi = l_qf1*sqrt(k);
% M4_F1 = [cos(phi)           (1/sqrt(k))*sin(phi)	0 0;
%          -sqrt(k)*sin(phi)	cos(phi)                0 0;
%          0 0	cosh(phi)          (1/sqrt(k))*sinh(phi);
%          0 0	sqrt(k)*sinh(phi)	cosh(phi)           ];

% d = 0.2;
% M4_03 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% l_qd1 = 0.300; fqdl4 = clight*1e-6*0.335;
% k = abs(fqdl4 * ID1 / p); phi = l_qd1*sqrt(k);
% M4_D1 = [cosh(phi)          (1/sqrt(k))*sinh(phi)	0 0;
%          sqrt(k)*sinh(phi)	cosh(phi)               0 0;
%          0 0    cos(phi)            (1/sqrt(k))*sin(phi);
%          0 0    -sqrt(k)*sin(phi)   cos(phi)            ];

% d = 0.11 + l_cor/2;
% M4_04 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% Kicker 2 here (middle)
d = l_cor/2 + 0.96 + l_cor/2;
M4_05 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% Kicker 3 here (middle)
d = l_cor/2 + 0.007 + l_bpm/2;
M4_06 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% BPM 1 here (middle)
d = l_bpm/2 + 0.2205 + 0.032;
M4_07 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

l_qf2 = 0.186; fqdx = clight*1e-6*0.873;
k = abs(fqdx * IF / p); phi = l_qf2*sqrt(k);
M4_F2 = [cos(phi)           (1/sqrt(k))*sin(phi)	0 0;
         -sqrt(k)*sin(phi)	cos(phi)                0 0;
         0 0	cosh(phi)           (1/sqrt(k))*sinh(phi);
         0 0	sqrt(k)*sinh(phi)	cosh(phi)           ];
% M4_F2 = [cosh(phi)          (1/sqrt(k))*sinh(phi)	0 0;
%          sqrt(k)*sinh(phi)	cosh(phi)               0 0;
%          0 0	cos(phi)            (1/sqrt(k))*sin(phi);
%          0 0	-sqrt(k)*sin(phi)	cos(phi)           ];

d = 0.054 + l_bpm/2;
M4_08 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

% BPM 2 here (middle) 
d = l_bpm/2 + 0.022 + 0.070319 + 0.79785 + 0.1218 + 0.032;
M4_09 = [1 d 0 0; 0 1 0 0; 0 0 1 d; 0 0 0 1];

%% Make transport matrices from each corrector to each BPM
% Transport matrix for corrector j -> BPM i = M4ij
% M411 = M4_06 * M4_05 * M4_04 * M4_D1 * M4_03 * M4_F1 * M4_02 * M4_RB * M4_01;
% M421 = M4_08 * M4_F2 * M4_07 * M411;
% M431 = M4_09 * M421;
% M412 = M4_06 * M4_05;
M422 = M4_08 * M4_F2 * M4_07 * M4_06 * M4_05;
M432 = M4_09 * M422;
% M413 = M4_06;
M423 = M4_08 * M4_F2 * M4_07 * M4_06;
M433 = M4_09 * M423;

%% Make response matrices for x and y
% Rx = [M411(1,2) M412(1,2) M413(1,2);
%       M421(1,2) M422(1,2) M423(1,2);
%       M431(1,2) M432(1,2) M433(1,2)];
% Ry = [M411(3,4) M412(3,4) M413(3,4);
%       M421(3,4) M422(3,4) M423(3,4);
%       M431(3,4) M432(3,4) M433(3,4)];
Rx = [M422(1,2) M423(1,2);
      M432(1,2) M433(1,2)];
Ry = [M422(3,4) M423(3,4);
      M432(3,4) M433(3,4)];
