function DrawBetas(handles)
% DrawBetas()
% -----------
% Read beta functions along the lattice from madx output file ('twiss_tbl')
% and display them in the current axes
global G_l_tbl;

%% Read mad-x twiss file
fid = fopen('madx_output_twiss');
C = textscan(fid, '%q %f %f %f %f %*[^\n]', 'Headerlines', 47);
pos = C{:,2};
betx = C{:,4};
bety = C{:,5};
fclose(fid);

%% Plot the beta functions
hold(handles.axBeta, 'on');
plot(handles.axBeta, pos, betx, 'b', 'LineWidth', 2);
plot(handles.axBeta, pos, bety, 'r', 'LineWidth', 2);
hold(handles.axBeta, 'off');

%% Enhance plot
% l_end = pos(length(pos));
maxval = max(max(betx),max(bety));
text(0.98*G_l_tbl, 0.99*maxval, ...
    '\fontsize{16}\it\color{blue}\beta_x, \color{red}\beta_y \fontsize{12}\rm\color{black}[m]', ...
    'VerticalAlignment', 'top', 'HorizontalAlignment', 'right', 'Parent', handles.axBeta);
% axis([0 l_end 0 maxval]);
% box on;
