function DrawPETSPositionFigure(posX, posY, sigmaX, sigmaY)
global G_PetsApertureRadius;
hold on;

% Circle for the aperture
t = 0:pi/50:2*pi;
fill(G_PetsApertureRadius*cos(t), G_PetsApertureRadius*sin(t), 'black');

% Draw beam size with 1 and 3 sigmas
fill(3*sigmaX*cos(t)+posX*ones(size(t)), 3*sigmaY*sin(t)+posY*ones(size(t)), ...
    [0.8 0.4 0.4], 'EdgeColor', 'none');
fill(2*sigmaX*cos(t)+posX*ones(size(t)), 2*sigmaY*sin(t)+posY*ones(size(t)), ...
    [0.9 0.6 0.6], 'EdgeColor', 'none');
fill(sigmaX*cos(t)+posX*ones(size(t)), sigmaY*sin(t)+posY*ones(size(t)), ...
    [1 0.8 0.8], 'EdgeColor', 'none');

% Arrow showing aperture radius with text
% plot([1 1.2 1.1 1.1]*G_PetsApertureRadius, [0 0 0 0.35]*G_PetsApertureRadius, 'k');
% plot([1 1.2 1.1 1.1]*G_PetsApertureRadius, [1 1 1 0.65]*G_PetsApertureRadius, 'k');
% text(1.3*G_PetsApertureRadius, G_PetsApertureRadius*0.5, ['\fontsize{9}' num2str(G_PetsApertureRadius, '%2.1f')], ...
%     'HorizontalAlignment', 'right')

% Line showing wanted beam position
plot([0, posX], [0, posY], 'w-x');

% Miscellaneous
% text(1.3*G_PetsApertureRadius, -G_PetsApertureRadius, '[mm]', 'HorizontalAlignment', 'right', ...
%     'VerticalAlignment', 'bottom');
axis([-1 1 -1 1] * G_PetsApertureRadius);
axis off;