

folder(1).name = '100901_0mm_BadBpmSignals';
folder(2).name = '100901_5mmH_BadBpmSignals';
folder(3).name = '100901_-5mmH_BadBpmSignals';
folder(4).name = '100901_2mmV_BadBpmSignals';
folder(5).name = '100901_-3mmV_BadBpmSignals';

windowBpm = 1478:1715;
windowRf = windowBpm - 1403*ones(size(windowBpm));

powerRatio = zeros(300, length(folder));

for i = 1:length(folder)
    filenames = FindAllDataFiles(folder(i).name);
    folder(i).N_files = length(filenames);
    
    for j = 1:folder(i).N_files
        load(char(filenames(j)));
        
        [rfL, rfR] = MakeNewRfPulses(IQRawI1, IQRawQ1, IQRawI2, IQRawQ2);
        powerRatio(j, i) = mean(rfL(windowRf) ./ rfR(windowRf));
    end
    
    folder(i).mean = mean(powerRatio(1:folder(i).N_files, i));
    folder(i).std = std(powerRatio(1:folder(i).N_files, i));
end

%% Plot the different series
clf, hold on
plot([1 1], [folder(3).mean-folder(3).std, folder(3).mean+folder(3).std], 'k-+');
plot(1, folder(3).mean, 'k*');
plot([2 2], [folder(4).mean-folder(4).std, folder(4).mean+folder(4).std], 'k-+');
plot(2, folder(4).mean, 'k*');
plot([3 3], [folder(1).mean-folder(1).std, folder(1).mean+folder(1).std], 'k-+');
plot(3, folder(1).mean, 'k*');
plot([4 4], [folder(5).mean-folder(5).std, folder(5).mean+folder(5).std], 'k-+');
plot(4, folder(5).mean, 'k*');
plot([5 5], [folder(2).mean-folder(2).std, folder(2).mean+folder(2).std], 'k-+');
plot(5, folder(2).mean, 'k*');

set(gca, 'XLim', [0 6]);