function varargout = GUI1(varargin)
% GUI1 M-file for GUI1.fig
%      GUI1, by itself, creates a new GUI1 or raises the existing
%      singleton*.
%
%      H = GUI1 returns the handle to a new GUI1 or the handle to
%      the existing singleton*.
%
%      GUI1('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI1.M with the given input arguments.
%
%      GUI1('Property','Value',...) creates a new GUI1 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI1_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI1_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI1

% EA: some other comments
% put in same b,a,e in both planes, update phase-space : not the
% same beam?   -> Investigate!


% Last Modified by GUIDE v2.5 14-Jul-2010 16:58:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI1_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI1_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI1 is made visible.
function GUI1_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI1 (see VARARGIN)

% Choose default command line output for GUI1
handles.output = hObject;

% Add other folders to the search path while Matlab runs
global G_path;
G_path = pwd;   % Set globally to avoid crashing due to relative paths
addpath(G_path);
addpath([G_path '/callbacks']);
addpath([G_path '/../../common']);
addpath([G_path '/../../JavaCoInterface']);
addpath([G_path '/..']);

% Unix commands to run Placet correctly
% system('setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:/acc/oper/share/ctf/data/ctfmod/placet/placet-development/bin');
% system('alias placet /acc/oper/share/ctf/data/ctfmod/placet/placet-development/bin/placet-octave');
% system('LD_LIBRARY_PATH=/acc/oper/share/ctf/data/ctfmod/placet/placet-development/bin');
% system('alias placet=/acc/oper/share/ctf/data/ctfmod/placet/placet-development/bin/placet-octave');

% Make global variables for use in different parts of the program
global G_pos_bpm;             % Positions and lengths of all BPMs
global G_l_tbl;               % Length of the entire lattice
global G_no_pets;             % Number of PETS, used for quad scaling
global G_quads;               % List of quads
global G_isonline;            % If the program is online or not
global G_timerobj;            % Timer object
global G_last_tstamp;         % Timestamp for BPM readings

% Initiate the timestamp for BPM readings
fid = fopen([G_path '/BPMOutput/mean.txt']);
G_last_tstamp = str2double(fgetl(fid));
fclose(fid);

% Make a list of the needed devies and store them globally
MakeListOfDevices();

% Read parameters, store some globally, write some to textboxes
ReadParametersFromFile(handles);

% Make the other 1-2 user screens (for not having too many overlapping elements in GUIDE)
handles = MakeGUIPanelPETS(hObject, handles);

% Make math text (greek etc) in axes
MakeMathText(handles);

% Read madx survey file, save some of the parameters in handles for later use
[pos_qf, pos_qd, G_pos_bpm, pos_mtv, pos_cor, pos_bend, pos_pets, G_l_tbl, pos_zero] ...
    = LatticeFromMadx();
G_no_pets = size(pos_pets, 2);

% Draw lattice
DrawLattice(handles, pos_qf, pos_qd, G_pos_bpm, pos_mtv, pos_cor, ...
    pos_bend, pos_pets, G_l_tbl, pos_zero);

% Update phase space diagram
UpdatePhaseSpace(handles);

% Make adjustments to the two empty graphs
set(handles.axPos, 'XLim', [0 G_l_tbl], 'Box', 'on');
set(handles.axBeta, 'XLim', [0 G_l_tbl], ...
    'XTick', [0 5 10 15 20 25 30 35 G_l_tbl], 'Box', 'on');

% Make the steering controls
MakeSteeringControls(handles);

% Set the correct text for the BPM scaling
val = round(get(handles.sldBPMScale, 'Value'));
scales = [0.09 0.12 0.15 0.30 0.45 0.60 0.90 1.20 1.50 3.00 6.00 9.00 12.00];
set(handles.txtBPMScale, ...
    'String', ['BPM position scale: ' num2str(scales(val)) ' mm']);

% Start with panel 1
set(handles.btnPanel1, 'Value', 1);
UIPanels(1, handles);

% Read the first quads and write values to the textboxes
if G_isonline
    quadvals = readdevices_gui(G_quads(1,1:6));
    quadstr1 = num2str(quadvals(1), '%5.2f');
    quadstr2 = num2str(quadvals(2), '%5.2f');
    quadstr3 = num2str(quadvals(3), '%5.2f');
    quadstr4 = num2str(quadvals(4), '%5.2f');   
    quadstr5 = num2str(quadvals(5), '%5.2f');
    quadstr6 = num2str(quadvals(6), '%5.2f');   
    set(handles.edtCurrent1, 'String', quadstr1);
    set(handles.edtCurrent2, 'String', quadstr2);
    set(handles.edtCurrent3, 'String', quadstr3);
    set(handles.edtCurrent4, 'String', quadstr4);
    set(handles.edtCurrent5, 'String', quadstr5);
    set(handles.edtCurrent6, 'String', quadstr6);
end

% Calculate the power prediction for screen 2
btnPowerPred_callback(0, 0, handles);

% Make sure bpm subscription is enabled, then start subscription
if G_isonline
    fid = fopen([G_path '/onOffSubscription'], 'w');
    fprintf(fid, '1');
    fclose(fid);
end

system(['java -jar ' G_path '/subscAndDump2.jar &']);    % 2 is the new version

% Make timer and start it
G_timerobj = timer('Period', 1.2, 'ExecutionMode', 'fixedRate', ...
    'TimerFcn', {'timerFunction', handles});
start(G_timerobj);
disp(['Timer started.']);

% UIWAIT makes GUI1 wait for user response (see UIRESUME)
% uiwait(handles.gui1);


% --- Outputs from this function are returned to the command line.
function varargout = GUI1_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
if (~isempty(findobj('tag','gui1')) && strcmp(get(handles.pnlMatch, 'Visible'), 'on'))
    varargout{1} = handles.output;
end



function edtBetaX_Callback(hObject, eventdata, handles)
% hObject    handle to edtBetaX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtBetaX as text
%        str2double(get(hObject,'String')) returns contents of edtBetaX as a double


% --- Executes during object creation, after setting all properties.
function edtBetaX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtBetaX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtAlphaX_Callback(hObject, eventdata, handles)
% hObject    handle to edtAlphaX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtAlphaX as text
%        str2double(get(hObject,'String')) returns contents of edtAlphaX as a double


% --- Executes during object creation, after setting all properties.
function edtAlphaX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtAlphaX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtBetaY_Callback(hObject, eventdata, handles)
% hObject    handle to edtBetaY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtBetaY as text
%        str2double(get(hObject,'String')) returns contents of edtBetaY as a double


% --- Executes during object creation, after setting all properties.
function edtBetaY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtBetaY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtAlphaY_Callback(hObject, eventdata, handles)
% hObject    handle to edtAlphaY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtAlphaY as text
%        str2double(get(hObject,'String')) returns contents of edtAlphaY as a double


% --- Executes during object creation, after setting all properties.
function edtAlphaY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtAlphaY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnPhaseSpace.
function btnPhaseSpace_Callback(hObject, eventdata, handles)
% hObject    handle to btnPhaseSpace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
UpdatePhaseSpace(handles);


% --- Executes on button press in btnMatch.
function btnMatch_Callback(hObject, eventdata, handles)
% hObject    handle to btnMatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_l_tbl;
global G_isonline;

set(handles.txtMatchPenalty, 'String', 'Performing matching... Please wait.', ...
    'ForegroundColor', 'r');
cla(handles.axBeta)

% Find FODO currents from the desired phase advances
I = DisplayFodoIUsingPhi(handles);  % With minimization algotithm, may give different results

if G_isonline
    I820 = JGetCoValueFesa('CC.QDD0820', 'Acquisition', 'current');
    I840 = JGetCoValueFesa('CC.QFD0840', 'Acquisition', 'current');
else
    I820 = str2double(get(handles.edtCurrent1, 'String'));
    I840 = str2double(get(handles.edtCurrent2, 'String'));
end

% Write madx input file
beta0X = str2double(get(handles.edtBetaX, 'String'));
alpha0X = str2double(get(handles.edtAlphaX, 'String'));
beta0Y = str2double(get(handles.edtBetaY, 'String'));
alpha0Y = str2double(get(handles.edtAlphaY, 'String'));
E = str2double(get(handles.txtEnStartVal, 'String'));
% IQF = str2double(get(handles.edtCurrent1, 'String'));
% IQD = str2double(get(handles.edtCurrent2, 'String'));
[betaX, alphaX, betaY, alphaY] = ...
    TransportTwiss_BeforeWall(I820, I840, beta0X, alpha0X, beta0Y, alpha0Y, E);
CalcFodoPhaseAdvAndWriteToMadx(I(1), I(2), betaX, alphaX, betaY, alphaY, E, I820, I840);

% Execute madx script
system('madx < TBLcomplete.madx')

% Display magnet currents
[current_vals, penalty] = ReadMatchedCurrents();
set(handles.edtCurrent1, 'String', strtrim(current_vals(1,:)));
set(handles.edtCurrent2, 'String', strtrim(current_vals(2,:)));
set(handles.edtCurrent3, 'String', strtrim(current_vals(3,:)));
set(handles.edtCurrent4, 'String', strtrim(current_vals(4,:)));
set(handles.edtCurrent5, 'String', strtrim(current_vals(5,:)));
set(handles.edtCurrent6, 'String', strtrim(current_vals(6,:)));

% Display text with matching result (penalty function)
if (str2double(penalty) <= 1e-10)
    set(handles.txtMatchPenalty, 'ForegroundColor', 'k', 'String', ...
        ['Matching result: Success!   (Penalty function of ' penalty ')'], ...
        'Visible', 'on');
else
    set(handles.txtMatchPenalty, 'ForegroundColor', 'k', 'String', ...
        ['Matching result: Not successful.   (Penalty function of ' penalty ')'], ...
        'Visible', 'on');
end

% Read beta function from madx output and display it
% axes(handles.axBeta)
DrawBetas(handles);
set(handles.axBeta, 'YTickMode', 'auto', 'YGrid','on', 'XLim', [0 G_l_tbl], 'box', 'on');


function edtIF_Callback(hObject, eventdata, handles)
% hObject    handle to edtIF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIF as text
%        str2double(get(hObject,'String')) returns contents of edtIF as a double


% --- Executes during object creation, after setting all properties.
function edtIF_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edtID_Callback(hObject, eventdata, handles)
% hObject    handle to edtID (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtID as text
%        str2double(get(hObject,'String')) returns contents of edtID as a double


% --- Executes during object creation, after setting all properties.
function edtID_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtID (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on edtIF and none of its controls.
function edtIF_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edtIF (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over btnPanel1.
function btnPanel1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to btnPanel1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in btnPanel1.
function btnPanel1_Callback(hObject, eventdata, handles)
% hObject    handle to btnPanel1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.btnPanel1,'Value',1);
set(handles.btnPanel2,'Value',0);
set(handles.btnPanel3,'Value',0);
UIPanels(1, handles);

% Hint: get(hObject,'Value') returns toggle state of btnPanel1


% --- Executes on button press in btnPanel2.
function btnPanel2_Callback(hObject, eventdata, handles)
% hObject    handle to btnPanel2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.btnPanel1,'Value',0);
set(handles.btnPanel2,'Value',1);
set(handles.btnPanel3,'Value',0);
UIPanels(2, handles);

% Hint: get(hObject,'Value') returns toggle state of btnPanel2


% --- Executes on button press in btnPanel3.
function btnPanel3_Callback(hObject, eventdata, handles)
% hObject    handle to btnPanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.btnPanel1,'Value',0);
set(handles.btnPanel2,'Value',0);
set(handles.btnPanel3,'Value',1);
UIPanels(3, handles);

% Hint: get(hObject,'Value') returns toggle state of btnPanel3


% --- Executes on button press in btnSave.
function btnSave_Callback(hObject, eventdata, handles)
% hObject    handle to btnSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%str = get(handles.txtCurrents, 'String');
%fid = fopen('saved', 'w');
%for i = 1:size(str, 1)
%    strpart = str(i,:);
%    strpart = strpart(1:length(strpart)-2); % Remove ' A' from string
%    strpart = [strpart '0'];  % Make space for the ':' in ':='
%    l = length(strpart);
%    strpart(l-6:l) = strpart(l-7:l-1);  % Move the last chars
%    strpart(l-7) = ':';
%    strpart = strpart
%end
%SaveSettings();   


function edtCurrent1_Callback(hObject, eventdata, handles)
% hObject    handle to edtCurrent1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtCurrent1 as text
%        str2double(get(hObject,'String')) returns contents of edtCurrent1 as a double


% --- Executes during object creation, after setting all properties.
function edtCurrent1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtCurrent1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtCurrent2_Callback(hObject, eventdata, handles)
% hObject    handle to edtCurrent2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtCurrent2 as text
%        str2double(get(hObject,'String')) returns contents of edtCurrent2 as a double


% --- Executes during object creation, after setting all properties.
function edtCurrent2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtCurrent2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtCurrent3_Callback(hObject, eventdata, handles)
% hObject    handle to edtCurrent3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtCurrent3 as text
%        str2double(get(hObject,'String')) returns contents of edtCurrent3 as a double


% --- Executes during object creation, after setting all properties.
function edtCurrent3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtCurrent3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtCurrent4_Callback(hObject, eventdata, handles)
% hObject    handle to edtCurrent4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtCurrent4 as text
%        str2double(get(hObject,'String')) returns contents of edtCurrent4 as a double


% --- Executes during object creation, after setting all properties.
function edtCurrent4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtCurrent4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX1_Callback(hObject, eventdata, handles)
% hObject    handle to edtX1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX1 as text
%        str2double(get(hObject,'String')) returns contents of edtX1 as a double


% --- Executes during object creation, after setting all properties.
function edtX1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY1_Callback(hObject, eventdata, handles)
% hObject    handle to edtY1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY1 as text
%        str2double(get(hObject,'String')) returns contents of edtY1 as a double


% --- Executes during object creation, after setting all properties.
function edtY1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX2_Callback(hObject, eventdata, handles)
% hObject    handle to edtX2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX2 as text
%        str2double(get(hObject,'String')) returns contents of edtX2 as a double


% --- Executes during object creation, after setting all properties.
function edtX2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY2_Callback(hObject, eventdata, handles)
% hObject    handle to edtY2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY2 as text
%        str2double(get(hObject,'String')) returns contents of edtY2 as a double


% --- Executes during object creation, after setting all properties.
function edtY2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX3_Callback(hObject, eventdata, handles)
% hObject    handle to edtX3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX3 as text
%        str2double(get(hObject,'String')) returns contents of edtX3 as a double


% --- Executes during object creation, after setting all properties.
function edtX3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY3_Callback(hObject, eventdata, handles)
% hObject    handle to edtY3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY3 as text
%        str2double(get(hObject,'String')) returns contents of edtY3 as a double


% --- Executes during object creation, after setting all properties.
function edtY3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnResetSteering.
function btnResetSteering_Callback(hObject, eventdata, handles)
% hObject    handle to btnResetSteering (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.btnEditSteering, 'Value', 1);
set(handles.btnSteerToHW, 'Enable', 'on');

set(handles.edtIC1X, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC1Y, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC2X, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC2Y, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC3X, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC3Y, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC4X, 'Enable', 'on', 'String', '0.0');
set(handles.edtIC4Y, 'Enable', 'on', 'String', '0.0');
% set(handles.edtX1, 'Enable', 'on', 'String', '0');
% set(handles.edtY1, 'Enable', 'on', 'String', '0');
% set(handles.edtX2, 'Enable', 'on', 'String', '0');
% set(handles.edtY2, 'Enable', 'on', 'String', '0');
% set(handles.edtX3, 'Enable', 'on', 'String', '0');
% set(handles.edtY3, 'Enable', 'on', 'String', '0');
% set(handles.edtX4, 'Enable', 'on', 'String', '0');
% set(handles.edtY4, 'Enable', 'on', 'String', '0');
% set(handles.edtX5, 'Enable', 'on', 'String', '0');
% set(handles.edtY5, 'Enable', 'on', 'String', '0');
% set(handles.edtX6, 'Enable', 'on', 'String', '0');
% set(handles.edtY6, 'Enable', 'on', 'String', '0');
% set(handles.edtX7, 'Enable', 'on', 'String', '0');
% set(handles.edtY7, 'Enable', 'on', 'String', '0');
% set(handles.edtX8, 'Enable', 'on', 'String', '0');
% set(handles.edtY8, 'Enable', 'on', 'String', '0');
% set(handles.edtX9, 'Enable', 'on', 'String', '0');
% set(handles.edtY9, 'Enable', 'on', 'String', '0');
% set(handles.edtX10, 'Enable', 'on', 'String', '0');
% set(handles.edtY10, 'Enable', 'on', 'String', '0');
% set(handles.edtX11, 'Enable', 'on', 'String', '0');
% set(handles.edtY11, 'Enable', 'on', 'String', '0');
% set(handles.edtX12, 'Enable', 'on', 'String', '0');
% set(handles.edtY12, 'Enable', 'on', 'String', '0');
% set(handles.edtX13, 'Enable', 'on', 'String', '0');
% set(handles.edtY13, 'Enable', 'on', 'String', '0');
% set(handles.edtX14, 'Enable', 'on', 'String', '0');
% set(handles.edtY14, 'Enable', 'on', 'String', '0');
% set(handles.edtX15, 'Enable', 'on', 'String', '0');
% set(handles.edtY15, 'Enable', 'on', 'String', '0');
% set(handles.edtX16, 'Enable', 'on', 'String', '0');
% set(handles.edtY16, 'Enable', 'on', 'String', '0');
set(handles.edtBendCurrent, 'Enable', 'on', 'String', '0.0');


% --- Executes on button press in 1Steering.
function btn1to1Steering_Callback(hObject, eventdata, handles)
% hObject    handle to btn1to1Steering (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[R0x, R0y] = GetResponsePlacet(handles);
Steering1to1(R0x, R0y, 1, handles);


function edtX4_Callback(hObject, eventdata, handles)
% hObject    handle to edtX4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX4 as text
%        str2double(get(hObject,'String')) returns contents of edtX4 as a double


% --- Executes during object creation, after setting all properties.
function edtX4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY4_Callback(hObject, eventdata, handles)
% hObject    handle to edtY4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY4 as text
%        str2double(get(hObject,'String')) returns contents of edtY4 as a double


% --- Executes during object creation, after setting all properties.
function edtY4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX5_Callback(hObject, eventdata, handles)
% hObject    handle to edtX5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX5 as text
%        str2double(get(hObject,'String')) returns contents of edtX5 as a double


% --- Executes during object creation, after setting all properties.
function edtX5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY5_Callback(hObject, eventdata, handles)
% hObject    handle to edtY5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY5 as text
%        str2double(get(hObject,'String')) returns contents of edtY5 as a double


% --- Executes during object creation, after setting all properties.
function edtY5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX6_Callback(hObject, eventdata, handles)
% hObject    handle to edtX6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX6 as text
%        str2double(get(hObject,'String')) returns contents of edtX6 as a double


% --- Executes during object creation, after setting all properties.
function edtX6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY6_Callback(hObject, eventdata, handles)
% hObject    handle to edtY6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY6 as text
%        str2double(get(hObject,'String')) returns contents of edtY6 as a double


% --- Executes during object creation, after setting all properties.
function edtY6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX7_Callback(hObject, eventdata, handles)
% hObject    handle to edtX7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX7 as text
%        str2double(get(hObject,'String')) returns contents of edtX7 as a double


% --- Executes during object creation, after setting all properties.
function edtX7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY7_Callback(hObject, eventdata, handles)
% hObject    handle to edtY7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY7 as text
%        str2double(get(hObject,'String')) returns contents of edtY7 as a double


% --- Executes during object creation, after setting all properties.
function edtY7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX8_Callback(hObject, eventdata, handles)
% hObject    handle to edtX8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX8 as text
%        str2double(get(hObject,'String')) returns contents of edtX8 as a double


% --- Executes during object creation, after setting all properties.
function edtX8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY8_Callback(hObject, eventdata, handles)
% hObject    handle to edtY8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY8 as text
%        str2double(get(hObject,'String')) returns contents of edtY8 as a double


% --- Executes during object creation, after setting all properties.
function edtY8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX9_Callback(hObject, eventdata, handles)
% hObject    handle to edtX9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX9 as text
%        str2double(get(hObject,'String')) returns contents of edtX9 as a double


% --- Executes during object creation, after setting all properties.
function edtX9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY9_Callback(hObject, eventdata, handles)
% hObject    handle to edtY9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY9 as text
%        str2double(get(hObject,'String')) returns contents of edtY9 as a double


% --- Executes during object creation, after setting all properties.
function edtY9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX10_Callback(hObject, eventdata, handles)
% hObject    handle to edtX10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX10 as text
%        str2double(get(hObject,'String')) returns contents of edtX10 as a double


% --- Executes during object creation, after setting all properties.
function edtX10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY10_Callback(hObject, eventdata, handles)
% hObject    handle to edtY10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY10 as text
%        str2double(get(hObject,'String')) returns contents of edtY10 as a double


% --- Executes during object creation, after setting all properties.
function edtY10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX11_Callback(hObject, eventdata, handles)
% hObject    handle to edtX11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX11 as text
%        str2double(get(hObject,'String')) returns contents of edtX11 as a double


% --- Executes during object creation, after setting all properties.
function edtX11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY11_Callback(hObject, eventdata, handles)
% hObject    handle to edtY11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY11 as text
%        str2double(get(hObject,'String')) returns contents of edtY11 as a double


% --- Executes during object creation, after setting all properties.
function edtY11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX12_Callback(hObject, eventdata, handles)
% hObject    handle to edtX12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX12 as text
%        str2double(get(hObject,'String')) returns contents of edtX12 as a double


% --- Executes during object creation, after setting all properties.
function edtX12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY12_Callback(hObject, eventdata, handles)
% hObject    handle to edtY12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY12 as text
%        str2double(get(hObject,'String')) returns contents of edtY12 as a double


% --- Executes during object creation, after setting all properties.
function edtY12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX13_Callback(hObject, eventdata, handles)
% hObject    handle to edtX13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX13 as text
%        str2double(get(hObject,'String')) returns contents of edtX13 as a double


% --- Executes during object creation, after setting all properties.
function edtX13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY13_Callback(hObject, eventdata, handles)
% hObject    handle to edtY13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY13 as text
%        str2double(get(hObject,'String')) returns contents of edtY13 as a double


% --- Executes during object creation, after setting all properties.
function edtY13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX14_Callback(hObject, eventdata, handles)
% hObject    handle to edtX14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX14 as text
%        str2double(get(hObject,'String')) returns contents of edtX14 as a double


% --- Executes during object creation, after setting all properties.
function edtX14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY14_Callback(hObject, eventdata, handles)
% hObject    handle to edtY14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY14 as text
%        str2double(get(hObject,'String')) returns contents of edtY14 as a double


% --- Executes during object creation, after setting all properties.
function edtY14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX15_Callback(hObject, eventdata, handles)
% hObject    handle to edtX15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX15 as text
%        str2double(get(hObject,'String')) returns contents of edtX15 as a double


% --- Executes during object creation, after setting all properties.
function edtX15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY15_Callback(hObject, eventdata, handles)
% hObject    handle to edtY15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY15 as text
%        str2double(get(hObject,'String')) returns contents of edtY15 as a double


% --- Executes during object creation, after setting all properties.
function edtY15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtX16_Callback(hObject, eventdata, handles)
% hObject    handle to edtX16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtX16 as text
%        str2double(get(hObject,'String')) returns contents of edtX16 as a double


% --- Executes during object creation, after setting all properties.
function edtX16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtX16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtY16_Callback(hObject, eventdata, handles)
% hObject    handle to edtY16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtY16 as text
%        str2double(get(hObject,'String')) returns contents of edtY16 as a double


% --- Executes during object creation, after setting all properties.
function edtY16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtY16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtCurrent5_Callback(hObject, eventdata, handles)
% hObject    handle to edtCurrent5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtCurrent5 as text
%        str2double(get(hObject,'String')) returns contents of edtCurrent5 as a double


% --- Executes during object creation, after setting all properties.
function edtCurrent5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtCurrent5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtCurrent6_Callback(hObject, eventdata, handles)
% hObject    handle to edtCurrent6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtCurrent6 as text
%        str2double(get(hObject,'String')) returns contents of edtCurrent6 as a double


% --- Executes during object creation, after setting all properties.
function edtCurrent6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtCurrent6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC1X_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC1X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC1X as text
%        str2double(get(hObject,'String')) returns contents of edtIC1X as a double


% --- Executes during object creation, after setting all properties.
function edtIC1X_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC1X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC1Y_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC1Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC1Y as text
%        str2double(get(hObject,'String')) returns contents of edtIC1Y as a double


% --- Executes during object creation, after setting all properties.
function edtIC1Y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC1Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC2X_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC2X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC2X as text
%        str2double(get(hObject,'String')) returns contents of edtIC2X as a double


% --- Executes during object creation, after setting all properties.
function edtIC2X_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC2X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC2Y_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC2Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC2Y as text
%        str2double(get(hObject,'String')) returns contents of edtIC2Y as a double


% --- Executes during object creation, after setting all properties.
function edtIC2Y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC2Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC3X_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC3X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC3X as text
%        str2double(get(hObject,'String')) returns contents of edtIC3X as a double


% --- Executes during object creation, after setting all properties.
function edtIC3X_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC3X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC3Y_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC3Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC3Y as text
%        str2double(get(hObject,'String')) returns contents of edtIC3Y as a double


% --- Executes during object creation, after setting all properties.
function edtIC3Y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC3Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnLoad.
function btnLoad_Callback(hObject, eventdata, handles)
% hObject    handle to btnLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in btnBPMZoom.
function btnBPMZoom_Callback(hObject, eventdata, handles)
% hObject    handle to btnBPMZoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of btnBPMZoom


% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edtBendCurrent_Callback(hObject, eventdata, handles)
% hObject    handle to edtBendCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtBendCurrent as text
%        str2double(get(hObject,'String')) returns contents of edtBendCurrent as a double


% --- Executes during object creation, after setting all properties.
function edtBendCurrent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtBendCurrent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnEditSteering.
function btnEditSteering_Callback(hObject, eventdata, handles)
% hObject    handle to btnEditSteering (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of btnEditSteering
val = get(handles.btnEditSteering, 'Value');
ControlSteeringControls(val, handles);


function edtIC4X_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC4X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC4X as text
%        str2double(get(hObject,'String')) returns contents of edtIC4X as a double


% --- Executes during object creation, after setting all properties.
function edtIC4X_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC4X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtIC4Y_Callback(hObject, eventdata, handles)
% hObject    handle to edtIC4Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtIC4Y as text
%        str2double(get(hObject,'String')) returns contents of edtIC4Y as a double


% --- Executes during object creation, after setting all properties.
function edtIC4Y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtIC4Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtEpsilonY_Callback(hObject, eventdata, handles)
% hObject    handle to edtEpsilonY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtEpsilonY as text
%        str2double(get(hObject,'String')) returns contents of edtEpsilonY as a double


% --- Executes during object creation, after setting all properties.
function edtEpsilonY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtEpsilonY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edtEpsilonX_Callback(hObject, eventdata, handles)
% hObject    handle to edtEpsilonX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtEpsilonX as text
%        str2double(get(hObject,'String')) returns contents of edtEpsilonX as a double


% --- Executes during object creation, after setting all properties.
function edtEpsilonX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtEpsilonX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnSetQuadCurrents.
function btnSetQuadCurrents_Callback(hObject, eventdata, handles)
% hObject    handle to btnSetQuadCurrents (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Need the number of PETS to determine current scaling
global G_no_pets; % Set elsewhere, used here for scope
global G_quads;

% Get the currents and the current scaling per PETS
try
    CC_QDD0820 = str2double(get(handles.edtCurrent1, 'String'));
    CC_QFD0840 = str2double(get(handles.edtCurrent2, 'String'));
    CC_QFL0910 = str2double(get(handles.edtCurrent3, 'String'));
    CC_QDL0920 = str2double(get(handles.edtCurrent4, 'String'));
    CB_QFM0110 = str2double(get(handles.edtCurrent5, 'String'));
    CB_QDM0120 = str2double(get(handles.edtCurrent6, 'String'));
    IF = str2double(get(handles.edtIF, 'String'));
    ID = str2double(get(handles.edtID, 'String'));
    DeltaEPerI = str2double(get(handles.edtGradPerI, 'String'));
    E = str2double(get(handles.txtEnStartVal, 'String'));
    if (isnan(CC_QDD0820) || isnan(CC_QFD0840) || isnan(CC_QFL0910) || isnan(CC_QDL0920) ...
            || isnan(CB_QFM0110) || isnan(CB_QDM0120) || isnan(IF) || isnan(ID) ...
            || isnan(DeltaEPerI) || isnan(E))
        errordlg(['An error ocurred when reading currents and energy loss. ' ...
        'Please check that all texboxes contain valid numbers.'], 'Wrong input');
        return;
    end
catch
    errordlg(['An error ocurred when reading currents and energy loss. ' ...
        'Please check that all texboxes contain valid numbers.'], 'Wrong input');
    return;
end

fid = fopen('BPMOutput/mean.txt');
input = textscan(fid, '%s %f', 'HeaderLines', 1);
input = input{:,2}';
fclose(fid);

% Read BPMs, set to zero if NaN values are read
if length(input) == 57
    bpm_cur = input(8:3:length(input));
    bpm_cur(isnan(bpm_cur)) = 0;
else
    disp('Error when reading BPMs. All BPM currents set to 0 - this affects scaling due to PETS.');
    bpm_cur = 1e-10 * ones(1,17);   % Set to a small value. Use 17 BPMs for consistency
end

% bpm_cur = input(9:3:length(input);
% EA: quick fix, set bpm_cur to 1e-10 while waiting for BPM reading to improve
% bpm_cur = 1e-10*ones(1,16);
% bpm_cur(isnan(bpm_cur)) = 0;

% Calculate the decreasing magnet currents
quad_cur = zeros(length(G_quads)-2, 1);
quad_cur(1) = CC_QDD0820;
quad_cur(2) = CC_QFD0840;
quad_cur(3) = CC_QFL0910;
quad_cur(4) = CC_QDL0920;
quad_cur(5) = CB_QFM0110;
quad_cur(6) = CB_QDM0120;

quad_cur(7) = IF;                                                               % CB.QFR0200
quad_cur(8) = ID * (E - min(1, G_no_pets) * DeltaEPerI * bpm_cur(1)) / E;       % CB.QDR0240
quad_cur(9) = IF * (E - min(2, G_no_pets) * DeltaEPerI * bpm_cur(2)) / E;       % CB.QFR0300
quad_cur(10) = ID * (E - min(3, G_no_pets) * DeltaEPerI * bpm_cur(3)) / E;       % CB_QDR0340
quad_cur(11) = IF * (E - min(4, G_no_pets) * DeltaEPerI * bpm_cur(4)) / E;       % CB_QFR0400
quad_cur(12) = ID * (E - min(5, G_no_pets) * DeltaEPerI * bpm_cur(5)) / E;       % CB_QDR0440
quad_cur(13) = IF * (E - min(6, G_no_pets) * DeltaEPerI * bpm_cur(6)) / E;       % CB_QFR0500
quad_cur(14) = ID * (E - min(7, G_no_pets) * DeltaEPerI * bpm_cur(7)) / E;       % CB_QDR0540
quad_cur(15) = IF * (E - min(8, G_no_pets) * DeltaEPerI * bpm_cur(8)) / E;       % CB_QFR0400
quad_cur(16) = ID * (E - min(9, G_no_pets) * DeltaEPerI * bpm_cur(9)) / E;      % CB_QDR0440
quad_cur(17) = IF * (E - min(10, G_no_pets) * DeltaEPerI * bpm_cur(10)) / E;	% CB_QFR0500
quad_cur(18) = ID * (E - min(11, G_no_pets) * DeltaEPerI * bpm_cur(11)) / E;	% CB_QDR0540
quad_cur(19) = IF * (E - min(12, G_no_pets) * DeltaEPerI * bpm_cur(12)) / E;	% CB_QFR0400
quad_cur(20) = ID * (E - min(13, G_no_pets) * DeltaEPerI * bpm_cur(13)) / E;	% CB_QDR0440
quad_cur(21) = IF * (E - min(14, G_no_pets) * DeltaEPerI * bpm_cur(14)) / E;	% CB_QFR0500
quad_cur(22) = ID * (E - min(15, G_no_pets) * DeltaEPerI * bpm_cur(15)) / E;	% CB_QDR0540
outputstr = [num2str(G_no_pets) ' PETS ==> '];
for i = 1:length(quad_cur)-1
    outputstr = [outputstr, num2str(quad_cur(i)) ', '];
end
outputstr = [outputstr, num2str(quad_cur(i))];
disp(outputstr);

% Write all currents to hardware
% quads = zeros(size(quad_cur,1),10);
% for i = 1:size(quad_cur,1)
%     size(G_quads(i).prefix), size(G_quads(i).name), size(quads(i))
%     quads(i,:) = char([G_quads(i).prefix, '.', G_quads(i).name]);
% end

% EA: changed so that two first quads are not overwritten
%WriteDevicesTBL(G_quads(1:length(G_quads)-2), quad_cur);
WriteDevicesTBL(G_quads(1:length(G_quads)-2), quad_cur(1:end));


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sldBPMScale_Callback(hObject, eventdata, handles)
% hObject    handle to sldBPMScale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
val = round(get(handles.sldBPMScale, 'Value'));
scales = [0.09 0.12 0.15 0.30 0.45 0.60 0.90 1.20 1.50 3.00 6.00 9.00 12.00];
set(handles.txtBPMScale, ...
    'String', ['BPM position scale: ' num2str(scales(val)) ' mm']);


% --- Executes during object creation, after setting all properties.
function sldBPMScale_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sldBPMScale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in btnDFSteering.
function btnDFSteering_Callback(hObject, eventdata, handles)
% hObject    handle to btnDFSteering (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in btnSteerToHW.
function btnSteerToHW_Callback(hObject, eventdata, handles)
% hObject    handle to btnSteerToHW (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_hcors, global G_vcors, global G_hmovers, global G_vmovers;

% Read corrector values from text boxes
hcors = zeros(1,4);
vcors = zeros(1,4);
hcors(1) = str2double(get(handles.edtIC1X, 'String'));
vcors(1) = str2double(get(handles.edtIC1Y, 'String'));
hcors(2) = str2double(get(handles.edtIC2X, 'String'));
vcors(2) = str2double(get(handles.edtIC2Y, 'String'));
hcors(3) = str2double(get(handles.edtIC3X, 'String'));
vcors(3) = str2double(get(handles.edtIC3Y, 'String'));
hcors(4) = str2double(get(handles.edtIC4X, 'String'));
vcors(4) = str2double(get(handles.edtIC4Y, 'String'));

% Read quadrupole positions form text boxes
quadposx = zeros(1,16);
quadposy = zeros(1,16);
quadposx(1) = str2double(get(handles.edtX1, 'String'));
quadposx(2) = str2double(get(handles.edtX2, 'String'));
quadposx(3) = str2double(get(handles.edtX3, 'String'));
quadposx(4) = str2double(get(handles.edtX4, 'String'));
quadposx(5) = str2double(get(handles.edtX5, 'String'));
quadposx(6) = str2double(get(handles.edtX6, 'String'));
quadposx(7) = str2double(get(handles.edtX7, 'String'));
quadposx(8) = str2double(get(handles.edtX8, 'String'));
quadposx(9) = str2double(get(handles.edtX9, 'String'));
quadposx(10) = str2double(get(handles.edtX10, 'String'));
quadposx(11) = str2double(get(handles.edtX11, 'String'));
quadposx(12) = str2double(get(handles.edtX12, 'String'));
quadposx(13) = str2double(get(handles.edtX13, 'String'));
quadposx(14) = str2double(get(handles.edtX14, 'String'));
quadposx(15) = str2double(get(handles.edtX15, 'String'));
quadposx(16) = str2double(get(handles.edtX16, 'String'));
quadposy(1) = str2double(get(handles.edtY1, 'String'));
quadposy(2) = str2double(get(handles.edtY2, 'String'));
quadposy(3) = str2double(get(handles.edtY3, 'String'));
quadposy(4) = str2double(get(handles.edtY4, 'String'));
quadposy(5) = str2double(get(handles.edtY5, 'String'));
quadposy(6) = str2double(get(handles.edtY6, 'String'));
quadposy(7) = str2double(get(handles.edtY7, 'String'));
quadposy(8) = str2double(get(handles.edtY8, 'String'));
quadposy(9) = str2double(get(handles.edtY9, 'String'));
quadposy(10) = str2double(get(handles.edtY10, 'String'));
quadposy(11) = str2double(get(handles.edtY11, 'String'));
quadposy(12) = str2double(get(handles.edtY12, 'String'));
quadposy(13) = str2double(get(handles.edtY13, 'String'));
quadposy(14) = str2double(get(handles.edtY14, 'String'));
quadposy(15) = str2double(get(handles.edtY15, 'String'));
quadposy(16) = str2double(get(handles.edtY16, 'String'));

% Write corrector currents
WriteDevicesTBL(G_hcors, hcors);
WriteDevicesTBL(G_vcors, vcors);

% Write quadrupole positions
for i = 1:length(quadposx)
    JSetCoValueFesa([G_hmovers(i).prefix '.' G_hmovers(i).name], ...
        'Position', 'position', quadposx(i));
    JSetCoValueFesa([G_vmovers(i).prefix '.' G_vmovers(i).name], ...
        'Position', 'position', quadposy(i));
end


function edtGradPerI_Callback(hObject, eventdata, handles)
% hObject    handle to edtGradPerI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edtGradPerI as text
%        str2double(get(hObject,'String')) returns contents of edtGradPerI as a double


% --- Executes during object creation, after setting all properties.
function edtGradPerI_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edtGradPerI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in btnPowerPred.
function btnPowerPred_Callback(hObject, eventdata, handles)
% hObject    handle to btnPowerPred (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% disp('dsw');


% --- Executes during object deletion, before destroying properties.
function gui1_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to gui1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_timerobj;
global G_isonline;
global G_path;
stop(G_timerobj);
delete(G_timerobj);      % Remove from memory
clear G_timerobj;

% Change folder to default to get final output there
system(['cd ' G_path]);

% Cancel the bpm subscription
if G_isonline
    fid = fopen('onOffSubscription', 'w');
    fprintf(fid, '0');
    fclose(fid);
end


% --- Executes on button press in btnExit.
function btnExit_Callback(hObject, eventdata, handles)
% hObject    handle to btnExit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(handles.gui1);