function MakeMathText(handles)
% Makes math text (greek etc) in different axes

% Alpha and beta labels
axes(handles.axAlphaBeta)
text(0.01, 0.85, '\it\fontsize{12}\beta_x\fontsize{8}\rm [m]:', 'HorizontalAlignment','left',...
    'VerticalAlignment', 'bottom');
text(0.01, 0.68, '\it\fontsize{12}\alpha_x\fontsize{8}\rm:', 'HorizontalAlignment','left',...
    'VerticalAlignment', 'bottom');
text(0.01, 0.51, '\it\fontsize{12}\epsilon_{Nx}\fontsize{8}\rm [{\mu}m]:', 'HorizontalAlignment','left',...
    'VerticalAlignment', 'bottom');
text(0.01, 0.33, '\it\fontsize{12}\beta_y\fontsize{8}\rm [m]:', 'HorizontalAlignment','left',...
    'VerticalAlignment', 'bottom');
text(0.01, 0.15, '\it\fontsize{12}\alpha_y\fontsize{8}\rm:', 'HorizontalAlignment','left',...
    'VerticalAlignment', 'bottom');
text(0.01, -0.02, '\it\fontsize{12}\epsilon_{Ny}\fontsize{8}\rm [{\mu}m]:', 'HorizontalAlignment','left',...
    'VerticalAlignment', 'bottom');
% axis off;

% IF and ID labels
axes(handles.axIFID)
text(0.5, 0.48,'\fontsize{10}\it{I}\rm_{F0,periodic}:', 'HorizontalAlignment','center',...
    'VerticalAlignment','bottom');
text(0.5,-0.05,'\fontsize{10}\it{I}\rm_{D0,periodic}:', 'HorizontalAlignment','center',...
    'VerticalAlignment','bottom');
% axis off;

% Change in gradient per beam current
axes(handles.axGradPerI)
text(0.0, -0.2, '\fontsize{10}\Delta\it{E}_{\rm{PETS}} / I_B\fontsize{8}\rm   [MeV/A]{:}', 'HorizontalAlignment', 'left',...
    'VerticalAlignment', 'bottom');
% axis off;

% Power prediction parameters
axes(handles.axPowerPredParams);
text(0.01, 0.55, '\fontsize{10}\it{F ( \lambda)}:', ...
    'HorizontalAlignment', 'left', 'VerticalAlignment', 'bottom');
text(0.01, 0.05, '\fontsize{10}\Delta\it{f}\rm [MHz]:', ...
    'HorizontalAlignment', 'left', 'VerticalAlignment', 'bottom');

axes(handles.axPowerProdFF);
text(0.5, 0.5, '\fontsize{10}\it{F ( \lambda)}:', ...
    'HorizontalAlignment', 'center', 'VerticalAlignment', 'middle');

% Power prediction formula
axes(handles.axPowerPredFormula);
% eq = [0 1 0 1 0 1; 1 1 0 0 1 0];
eq = double(imread('latex_powerPredEquation.jpg'));
bgcolor = mean(get(handles.gui1, 'Color'));
eq_scaled = eq * bgcolor / max(max(eq));
imshow(eq_scaled);
% text('Interpreter', 'latex', 'Position', [0, 0.5], 'FontSize', 14, 'String', ...
%     '$$\frac{1}{4}(R''/Q)\frac{\omega_{rf}}{v_g} L_{PETS}^2 I^2 F^2(\lambda) \eta_{\Omega,PETS}^2 \eta_{detuning}$$');

axis([handles.axAlphaBeta, handles.axIFID, handles.axGradPerI, handles.axPowerPredParams, handles.axPowerProdFF, handles.axPowerPredFormula], ...
    'off');
