function [currentVals, penalty] = ReadMatchedCurrents()
% Reads the output currents from madx and returns them as well as the
% penalty value.

%% Read mad-x currents file
fid = fopen('madx_output_variables');
currents = textscan(fid, '%q %*q %q');
currents = [currents{:,1} currents{:,2}];
fclose(fid);

%% Output the relevant currents
IQTL2a = '';
IQTL2b = '';
IQDD01 = '';
IQFD02 = '';
IQFM01 = '';
IQFM02 = '';
penalty = '';
for i = 1:size(currents,1)
    variable = char(currents(i,1));
    switch variable
        case 'iqtl2a'
            IQTL2a = char(currents(i,2));
            IQTL2a = IQTL2a(1:length(IQTL2a)-1); % Remove semicolon
            IQTL2a = str2double(IQTL2a); % Display a smaller number of digits
            IQTL2a = num2str(IQTL2a, '%4.2f');
        case 'iqtl2b'
            IQTL2b = char(currents(i,2));
            IQTL2b = IQTL2b(1:length(IQTL2b)-1); % Remove semicolon
            IQTL2b = str2double(IQTL2b); % Display a smaller number of digits
            IQTL2b = num2str(IQTL2b, '%4.2f');
        case 'iqdd01'
            IQDD01 = char(currents(i,2));
            IQDD01 = IQDD01(1:length(IQDD01)-1); % Remove semicolon
            IQDD01 = str2double(IQDD01); % Display a smaller number of digits
            IQDD01 = num2str(IQDD01, '%4.2f');
        case 'iqfd02'
            IQFD02 = char(currents(i,2));
            IQFD02 = IQFD02(1:length(IQFD02)-1); % Remove semicolon
            IQFD02 = str2double(IQFD02); % Display a smaller number of digits
            IQFD02 = num2str(IQFD02, '%4.2f');
        case 'iqfm01'
            IQFM01 = char(currents(i,2));
            IQFM01 = IQFM01(1:length(IQFM01)-1); % Remove semicolon
            IQFM01 = str2double(IQFM01); % Display a smaller number of digits
            IQFM01 = num2str(IQFM01, '%4.2f');
        case 'iqfm02'
            IQFM02 = char(currents(i,2));
            IQFM02 = IQFM02(1:length(IQFM02)-1); % Remove semicolon
            IQFM02 = str2double(IQFM02); % Display a smaller number of digits
            IQFM02 = num2str(IQFM02, '%4.2f');
        case 'tar'
            % madx matching penalty
            penalty = char(currents(i,2));
            penalty = penalty(1:length(penalty)-1); % Remove semicolon
            penalty = str2double(penalty); % Display a smaller number of digits
            penalty = num2str(penalty, '%2.1e');
    end
end

% Output matrices
currentVals = char(IQTL2a, IQTL2b, IQDD01, IQFD02, IQFM01, IQFM02);