function ReadParametersFromFile(handles)

% Define global parameters - can be used elsewhere
global G_isonline;
global G_PetsApertureRadius;
global G_iq_offset_I1, global G_iq_offset_I2, global G_iq_offset_I3, global G_iq_offset_I4;
global G_iq_offset_I5, global G_iq_offset_I6, global G_iq_offset_I7, global G_iq_offset_I8;
global G_iq_offset_Q1, global G_iq_offset_Q2, global G_iq_offset_Q3, global G_iq_offset_Q4;
global G_iq_offset_Q5, global G_iq_offset_Q6, global G_iq_offset_Q7, global G_iq_offset_Q8;
global G_iq_phi_1, global G_iq_phi_2, global G_iq_phi_3, global G_iq_phi_4;
global G_iq_phi_5, global G_iq_phi_6, global G_iq_phi_7, global G_iq_phi_8;
global G_iq_N_1, global G_iq_N_2, global G_iq_N_3, global G_iq_N_4;
global G_iq_N_5, global G_iq_N_6, global G_iq_N_7, global G_iq_N_8;
global G_iq_slope_1, global G_iq_slope_2;
global G_iq_attenuation_total_1, global G_iq_attenuation_total_2;

%% Read general parameters file, write to textboxes
fid = fopen('parameters_general.txt');
input = textscan(fid, '%s %f', 'HeaderLines', 4, 'Delimiter', '=');
input = input{:,2};
fclose(fid);

G_isonline = input(1);  % True or false
set(handles.txtEnStartVal, 'String', num2str(input(2),'%6.2f'));
set(handles.txtEnSpectrometerVal, 'String', num2str(input(3),'%6.2f'));
set(handles.edtBetaX, 'String', num2str(input(4)));
set(handles.edtAlphaX, 'String', num2str(input(5)));
set(handles.edtEpsilonX, 'String', num2str(input(6)));
set(handles.edtBetaY, 'String', num2str(input(7)));
set(handles.edtAlphaY, 'String', num2str(input(8)));
set(handles.edtEpsilonY, 'String', num2str(input(9)));
set(handles.edtGradPerI, 'String', num2str(input(10)));

%% Read PETS file
fid = fopen('parameters_pets.txt');
input = textscan(fid, '%s %f', 'HeaderLines', 4, 'Delimiter', '=');
input = input{:,2};
fclose(fid);
G_PetsApertureRadius = input(1);

%% Read iq calibration file
fid = fopen('parameters_iqcalibration.txt');
input = textscan(fid, '%s %f', 'HeaderLines', 4, 'Delimiter', '=');
input = input{:,2};
fclose(fid);

% Assign variables
G_iq_offset_I1 = input(1);
G_iq_offset_I2 = input(2);
G_iq_offset_I3 = input(3);
G_iq_offset_I4 = input(4);
G_iq_offset_I5 = input(5);
G_iq_offset_I6 = input(6);
G_iq_offset_I7 = input(7);
G_iq_offset_I8 = input(8);
G_iq_offset_Q1 = input(9);
G_iq_offset_Q2 = input(10);
G_iq_offset_Q3 = input(11);
G_iq_offset_Q4 = input(12);
G_iq_offset_Q5 = input(13);
G_iq_offset_Q6 = input(14);
G_iq_offset_Q7 = input(15);
G_iq_offset_Q8 = input(16);
G_iq_phi_1 = input(17);
G_iq_phi_2 = input(18);
G_iq_phi_3 = input(19);
G_iq_phi_4 = input(20);
G_iq_phi_5 = input(21);
G_iq_phi_6 = input(22);
G_iq_phi_7 = input(23);
G_iq_phi_8 = input(24);
G_iq_N_1 = input(25);
G_iq_N_2 = input(26);
G_iq_N_3 = input(27);
G_iq_N_4 = input(28);
G_iq_N_5 = input(29);
G_iq_N_6 = input(30);
G_iq_N_7 = input(31);
G_iq_N_8 = input(32);
G_iq_slope_1 = input(33);
G_iq_slope_2 = input(34);
G_iq_attenuation_total_1 = input(35);
G_iq_attenuation_total_2 = input(36);