function SaveSettings()
% Saves the magnet currents that are to be used for matching, in a madx
% input file.

%% Read mad-x currents file
fid = fopen('currents');
currents = textscan(fid, '%q %q %q');
currents = [currents{:,1} currents{:,2} currents{:,3}];
fclose(fid);

%% Write new file with currents
fid = fopen('saved', 'w');
for i = 1:size(currents,1)
    variable = char(currents(i,1));
    switch variable
        case 'iqdd01'
            str = [char(currents(i,1)) ' := ' char(currents(i,3)) '\n'];
            fprintf(fid, str);
        case 'iqfd02'
            str = [char(currents(i,1)) ' := ' char(currents(i,3)) '\n'];
            fprintf(fid, str);
        case 'iqfm01'
            str = [char(currents(i,1)) ' := ' char(currents(i,3)) '\n'];
            fprintf(fid, str);
        case 'iqfm02'
            str = [char(currents(i,1)) ' := ' char(currents(i,3))];
            fprintf(fid, str);
    end
end

fclose(fid);