function [SPosZ, SPosY] = ShapeBend(offset, l, scaling)
% Get the coordinates of a rectangular bend, to be used for making figures
% -------------------------------------
% offset:  The middle position along the lattice [m]
% l:       The length of the dipole [m]
% scaling: The height of the figure, e.g. 1

BendShape = [l/2 -l/2 -l/2 l/2 l/2; ...
          scaling scaling -scaling -scaling scaling];
SPosZ = BendShape(1,:) + offset*ones(1,size(BendShape,2));
SPosY = BendShape(2,:);