function [SPosZ, SPosY] = ShapeBpm(offset, l, scaling)
% Get the coordinates of a BPM, to be used for making figures
% -------------------------------------
% offset:  The middle position along the lattice [m]
% l:       The length of the BPM [m]
% scaling: The height of the figure multiplied by 3, e.g. 1

BpmShape = [l/2 -l/2 -l/2 l/2 l/2; ...
          scaling/3 scaling/3 -scaling/3 -scaling/3 scaling/3];
SPosZ = BpmShape(1,:) + offset*ones(1,size(BpmShape,2));
SPosY = BpmShape(2,:);