function [SPosZ1, SPosY1, SPosZ2, SPosY2] = ShapeCor(offset, l, scaling)
% Get the coordinates of a corrector magnet, to be used for making figures
% -------------------------------------
% offset:  The middle position along the lattice [m]
% l: Length of the corrector magnet
% scaling: The height of the figure multiplied by 3, e.g. 1

CorShape1 = [l/2 l/2 -l/2 -l/2 l/2; ...
          scaling/5 scaling/3 scaling/3 scaling/5 scaling/5];
CorShape2 = [l/2 l/2 -l/2 -l/2 l/2; ...
          -scaling/3 -scaling/5 -scaling/5 -scaling/3 -scaling/3];
SPosZ1 = CorShape1(1,:) + offset*ones(1,size(CorShape1,2));
SPosY1 = CorShape1(2,:);
SPosZ2 = CorShape2(1,:) + offset*ones(1,size(CorShape2,2));
SPosY2 = CorShape2(2,:);