function [SPosZ, SPosY] = ShapeMtv(offset, l, scaling)
% Get the coordinates of a MTV, to be used for making figures
% -------------------------------------
% offset: 	The middle position along the lattice [m]
% l:        The length of the emittance screen
% scaling:	The relative height of the figure, e.g. 1

MtvShape = [l/2 l/4 -l/4 -l/2 -l/2 -l/4 l/4 l/2 l/2; ...
          scaling/6 scaling/3 scaling/3 scaling/6 -scaling/6 -scaling/3 -scaling/3 -scaling/6 scaling/6];

if (offset > 38 && offset < 40)     % Particle path is bended here
    MtvShape = MtvShape - [0 0 0 0 0 0 0 0 0; ...
                           1 1 1 1 1 1 1 1 1] * 0.58*scaling;
end

SPosZ = MtvShape(1,:) + offset*ones(1,size(MtvShape,2));
SPosY = MtvShape(2,:);