function [SPosZ, SPosY] = ShapePets(offset, l, symbol_scaling)
% Get the coordinates of a PETS, to be used for making figures
% -------------------------------------
% offset:  The middle position along the lattice [m]
% l:       The length of the PETS [m]
% scaling: The height of the figure, e.g. 1

ss = symbol_scaling;
PetsShape = [l/2 -l/2 -l/2 l/2 l/2; ...
          ss/3 ss/3 -ss/3 -ss/3 ss/3];
    
SPosZ = PetsShape(1,:) + offset*ones(1,size(PetsShape,2));
SPosY = PetsShape(2,:);