function [SPosZ, SPosY] = ShapeQD(offset, l, scaling)
% Get the coordinates of a defocusing quad, to be used for making figures
% -------------------------------------
% offset:  The middle position along the lattice [m]
% l:       The length of the quad [m]
% scaling: The height of the figure, e.g. 1

QDShape = [l/8 l/2 -l/2 -l/8 -l/8 -l/2 l/2 l/8 l/8; ...
          scaling/3 scaling scaling scaling/3 -scaling/3 -scaling ...
               -scaling -scaling/3 scaling/3];
SPosZ = QDShape(1,:) + offset*ones(1,size(QDShape,2));
SPosY = QDShape(2,:);