function [SPosZ, SPosY] = ShapeQF(offset, l, scaling)
% Get the coordinates of a focusing quad, to be used for making figures
% -------------------------------------
% offset:  The middle position along the lattice [m]
% l:       The length of the quad [m]
% scaling: The height of the figure, e.g. 1

QFShape = [l/2 0 -l/2 -l/2 0 l/2 l/2; ...
           scaling/3 scaling scaling/3 -scaling/3 -scaling -scaling/3 scaling/3];
SPosZ = QFShape(1,:) + offset*ones(1,size(QFShape,2));
SPosY = QFShape(2,:);