function UIPanels(no, handles)
% Switches between the different user screens

% 'no' can be from 1 to 3, and controls which UI panel is shown.
global G_userscreen_no;   % Used elsewhere in the program
G_userscreen_no = no;

switch no;
    case 2      % PETS measurements
        set(handles.pnlEnergy,'Visible','off');
        set(handles.pnlMatch,'Visible','off')
        set(handles.pnlPhaseSpace,'Visible','off');
        set(handles.pnlPos,'Visible','off');
        set(handles.pnlSteering, 'Visible', 'off');
        pause(0.5);
        set(handles.pnlPETSPos,'Visible', 'on');
        set(handles.pnlPETSPred,'Visible','on');
        set(handles.pnlPulse,'Visible','on');
        set(handles.pnlPowerProd,'Visible','on');
        edtPETSPos_callback(0, 0, handles); % Update figure
    case 3      % Power and energy budget
        set(handles.pnlEnergy,'Visible','off');
        set(handles.pnlMatch,'Visible','off')
        set(handles.pnlPhaseSpace,'Visible','off');
        set(handles.pnlPos,'Visible','off');
        set(handles.pnlSteering, 'Visible', 'off');
        set(handles.pnlPETSPos,'Visible', 'off');
        set(handles.pnlPETSPred,'Visible','off');
        set(handles.pnlPulse,'Visible','off');
        set(handles.pnlPowerProd,'Visible','off');
        pause(0.5);
    otherwise   % Optics, matching, steering - will also be used if there is a wrong input
        set(handles.pnlPETSPos,'Visible', 'off');
        set(handles.pnlPETSPred,'Visible','off');
        set(handles.pnlPulse,'Visible','off');
        set(handles.pnlPowerProd,'Visible','off');
        pause(0.5);
        set(handles.pnlEnergy,'Visible','on');
        set(handles.pnlMatch,'Visible','on')
        set(handles.pnlPhaseSpace,'Visible','on');
        set(handles.pnlPos,'Visible','on');
        set(handles.pnlSteering, 'Visible', 'on');
end