function UpdateCorrectorsAndMovers(BendCurrentHandle)
% Reads corrector currents, bend currents and quad positions and displays
% them in text boxes.

% Global variables (defined elsewhere, written here for scope)
global ICor_handles;        % Matrix of handles
global posQuads_handles;    % Matrix of handles
global G_isonline;
global G_dipols, global G_hcors, global G_vcors;
global G_hmovers, global G_vmovers;

if G_isonline
    Dipol_val = readdevices_gui(G_dipols);
    ICor_val = zeros(2,4);
    ICor_val(1,:) = readdevices_gui(G_hcors);
    ICor_val(2,:) = readdevices_gui(G_vcors);
else
    ICor_val = [6.2 3.1 0.6 4.2;
                6.3 3.1 0.7 4.2];
    ICor_val = ICor_val + round(10*rand(size(ICor_val)))/100;
end

%
% TODO: Read quad positions
%
posQuads_val = zeros(2, 16);
for i = 1:size(posQuads_val, 2)
    posQuads_val(1,i) = JGetCoValueFesa([G_hmovers(i).prefix '.' G_hmovers(i).name], 'Position', 'position');
    posQuads_val(2,i) = JGetCoValueFesa([G_vmovers(i).prefix '.' G_vmovers(i).name], 'Position', 'position');
end
% posQuads_val = [-8476  2175 -8999  -735  9041  9161 -6806  1858 -3884 -3263 -8262 -3646  4471  4344 -1461  7946;
%                   396  4543 -6605 -2763  8643 -5870  1435  3972 -2123 -7421   978  9754  1442  9531  8260  6704];
% posQuads_val = posQuads_val + round(5*randn(size(posQuads_val)));

%% Write the values to the GUI
% Corrector currents
for i = 1:size(ICor_handles,1)
    for j = 1:size(ICor_handles,2)
        set(ICor_handles(i,j), 'String', num2str(ICor_val(i,j), '%3.2f'));
    end
end

% Quad positions
for i = 1:size(posQuads_handles,1)
    for j = 1:size(posQuads_handles,2)
        set(posQuads_handles(i,j), 'String', num2str(posQuads_val(i,j), '%4.0f'));
    end
end

% Dipole
set(BendCurrentHandle, 'String', num2str(Dipol_val(2), '%6.2f'));