function WriteDevicesTBL(devices, currents)

% Check that the vector of devices has the same size as the vector of
% currents
if (length(devices) ~= length(currents) )
    disp('Error: The number of devices and currents are different. No writing done.');
    return;
end


% Write currents to all devices
for i = 1:length(devices)
    devicename = [devices(i).prefix '.' devices(i).name];
    writedevice(devicename, 0, 1, currents(i));
end

  
