function btnPETSPos_callback(hObject, eventdata, handles)
% global space_2correctors;
global G_dipols, global G_hcors, global G_vcors;

% Get desired offsets
xpos = str2double(get(handles.edtPETSPosX, 'String'));
ypos = str2double(get(handles.edtPETSPosY, 'String'));

% Get beam momentum
E = str2double(get(handles.txtEnStartVal, 'String'));
p = sqrt(E^2 - 0.510998902^2);	% [MeV/c]

%% Calculate corrector currents and write to HW
% L = space_2correctors * 1e3;
% alphaX = tan(xpos/L) * 1e3;     % [mrad]
% alphaY = tan(ypos/L) * 1e3;     % [mrad]

% Currents as given by formula from integrated field
% IcorX = alphaX * p / 65.4;      % [A]
% IcorY = alphaY * p / 65.4;      % [A]

% disp(['alphaX = ' num2str(alphaX*180/pi) ' mrad, alphaY = ' num2str(alphaY*180/pi) ' mrad']);
% disp(['IX = ' num2str(IcorX) ' A, IY = ' num2str(IcorY) ' A']);

%% Make transport matrices, make response matrix, calculate required currents
%
% TODO: Read currents and BPMs, for now just use textbox values
%
try
%     Ib = readdevices_gui(G_dipols);     % Dipole
%     IF1 = JGetCoValueFesa('CB.QFM0110', 'Acquisition', 'current');
%     ID1 = JGetCoValueFesa('CB.QDM0120', 'Acquisition', 'current');
    IF = JGetCoValueFesa('CB.QFR0200', 'Acquisition', 'current');
    % realPosX1 = str2double(get(handles.txtPETSPosBPM1x, 'String'));
    realPosX2 = str2double(get(handles.txtPETSPosBPM2x, 'String'));
    realPosX3 = str2double(get(handles.txtPETSPosBPM3x, 'String'));
    % realPosY1 = str2double(get(handles.txtPETSPosBPM1y, 'String'));
    realPosY2 = str2double(get(handles.txtPETSPosBPM2y, 'String'));
    realPosY3 = str2double(get(handles.txtPETSPosBPM3y, 'String'));
    % realPosX1(isnan(realPosX1)) = 0;
    realPosX2(isnan(realPosX2)) = 0;
    realPosX3(isnan(realPosX3)) = 0;
    % realPosY1(isnan(realPosY1)) = 0;
    realPosY2(isnan(realPosY2)) = 0;
    realPosY3(isnan(realPosY3)) = 0;
catch
    s = lasterror;
    disp(['Error when reading signals for steering: ' s.message]);
end

% Calculate response matrix in each plane
[Rx, Ry] = CalcResponseMatrix_PETSOffset(IF, p);

% Calculate the necessary kick angles
DeltaPhiX = pinv(Rx) * ([xpos; xpos] - [realPosX2; realPosX3]);
DeltaPhiY = pinv(Ry) * ([ypos; ypos] - [realPosY2; realPosY3]);
% DeltaPhiX = pinv(Rx) * ([xpos; xpos] - [0; 0])
% DeltaPhiY = pinv(Ry) * ([ypos; ypos] - [0; 0])

% Determine the corresponding changes in currents
DeltaICorX = DeltaPhiX * p / 65.4;   % [A]
DeltaICorY = DeltaPhiY * p / 65.4;   % [A]

%% Communicate with HW
% Get the current currents
dhd0130 = JGetCoValueFesa('CB.DHD0130', 'Acquisition', 'current');
dhd0140 = JGetCoValueFesa('CB.DHD0140', 'Acquisition', 'current');
dvd0130 = JGetCoValueFesa('CB.DVD0130', 'Acquisition', 'current');
dvd0140 = JGetCoValueFesa('CB.DVD0140', 'Acquisition', 'current');

% Calculate the new currents
hcur = [dhd0130 dhd0140]+DeltaICorX'
vcur = [dvd0130 dvd0140]+DeltaICorY'

% Write the new currents
WriteDevicesTBL(G_hcors(2:3), hcur);
WriteDevicesTBL(G_vcors(2:3), vcur);