function edtPETSPos_callback(hObject, eventdata, handles)
% global G_PetsApertureRadius;
global G_isonline;

% Calculate radius and display
posX = str2double(get(handles.edtPETSPosX, 'String'));
posY = str2double(get(handles.edtPETSPosY, 'String'));
posR = sqrt(posX^2 + posY^2);

set(handles.txtPETSPosRVal, 'String', num2str(posR, '%3.3f'));

% Read twiss parameters and currents, transport them to the PETS
E = str2double(get(handles.txtEnStartVal, 'String'));
beta0x = str2double(get(handles.edtBetaX, 'String'));
beta0y = str2double(get(handles.edtBetaY, 'String'));
alpha0x = str2double(get(handles.edtAlphaX, 'String'));
alpha0y = str2double(get(handles.edtAlphaY, 'String'));
epsilonNX = str2double(get(handles.edtEpsilonX, 'String'));
epsilonNY = str2double(get(handles.edtEpsilonY, 'String'));

if G_isonline
    I3 = JGetCoValueFesa('CC.QFL0910', 'Acquisition', 'current');
    I4 = JGetCoValueFesa('CC.QDL0920', 'Acquisition', 'current');
    I5 = JGetCoValueFesa('CB.QFM0110', 'Acquisition', 'current');
    I6 = JGetCoValueFesa('CB.QDM0120', 'Acquisition', 'current');
    I7 = JGetCoValueFesa('CB.QFR0200', 'Acquisition', 'current');
else
    I3 = str2double(get(handles.edtCurrent3, 'String'));
    I4 = str2double(get(handles.edtCurrent4, 'String'));
    I5 = str2double(get(handles.edtCurrent5, 'String'));
    I6 = str2double(get(handles.edtCurrent6, 'String'));
    I7 = 0;
end

[betaX, alphaX, betaY, alphaY] = ...
    TransportTwiss_ToPets(I3,I4,I5,I6,I7,beta0x,alpha0x,beta0y,alpha0y,E);

% Geometric emittance
E_rest = 0.510998910;
gamma = E / E_rest;
beta = sqrt( 1 - 1/gamma^2 );
epsilonX = epsilonNX / beta / gamma;
epsilonY = epsilonNY / beta / gamma;

% Find sigmas
sigmaX = sqrt(betaX * epsilonX);
sigmaY = sqrt(betaY * epsilonY);

axes(handles.axPETSPos);
cla(handles.axPETSPos);

% Read aperture radius from file
% apertureradius = input(1);

DrawPETSPositionFigure(posX, posY, sigmaX, sigmaY);